<?php
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//
// $Id: auth.inc.php 205 2010-07-14 14:37:30Z egalstad $

include_once('utils.inc.php');

// redirect to login screen if user is not authenticated
function check_authentication($redirect=true){
	global $request;
	global $lstr;
	
	// some pages are used by both frontend and backend, so check for backend...
	if(defined("BACKEND")){
		echo "BACKEND DEFINED";
		check_backend_authentication();
		return;
		}
	
	if(is_authenticated()==false){
	
		// check backend ticket
		if(is_backend_authenticated()==true)
			return;

		// don't redirect user
		if($redirect==false){
			echo "Your session has timed out.";
			}
		
		// redirect user to login screen
		else{
			$redirecturl=$_SERVER['PHP_SELF'];
			$redirecturl.="%3f"; // question mark
		
			// add any variables present in original query string
			$request=array();
			grab_request_vars(false,"get");
			foreach($request as $var => $val){
				$redirecturl.="%26".$var."=".$val;
				}
		
			$theurl=get_base_url().PAGEFILE_LOGIN."?redirect=$redirecturl";
			//echo "THEURL: $theurl<BR>\n";
			header("Location: ".$theurl);
			}
		
		exit();
		}
	}

// checks if user is authenticated
function is_authenticated(){

	// some pages are used by both frontend and backend, so check for backend...
	if(defined("BACKEND")){
		return is_backend_authenticated();
		}

	// session variable is set, so they are already logged in
	if(isset($_SESSION["user_id"]))
		return true;
		
	// HTTP BASIC AUTHENTICATION support
	$remote_user="";
	if(isset($_SERVER["REMOTE_USER"]))
		$remote_user=$_SERVER["REMOTE_USER"];
	//echo "REMOTE USER: $remote_user<BR>";
	if($remote_user!=""){
		$uid=get_user_id($remote_user);
		//echo "UID: $uid<BR>";
		// user has authenticated, and they are configured in Nagios XI!
		if($uid>0){
			//echo "GOOD TO GO FOR BASIC AUTH!<BR>";
			// set session variables
			$_SESSION["user_id"]=$uid;
			$_SESSION["username"]=$remote_user;
			return true;
			}
		else{
			//echo "NO GO!<BR>";
			return false;
			}
		}
		
	//exit();

	return false;
	}
	
// check if HTTP BASIC authentication is being used
function is_http_basic_authenticated(){

	$remote_user="";
	if(isset($_SERVER["REMOTE_USER"]))
		$remote_user=$_SERVER["REMOTE_USER"];
	if($remote_user!="")
		return true;
	else
		return false;
	}
	
?>